//
//  ViewController.m
//  AppSettings
//
//  Created by Brian Moakley on 5/25/14.
//  Copyright (c) 2014 Razeware. All rights reserved.
//

#import "MoodViewController.h"
#import "RWTMood.h"

@interface MoodViewController ()

@property (weak, nonatomic) IBOutlet UITextField *firstName;
@property (weak, nonatomic) IBOutlet UITextField *lastName;
@property (weak, nonatomic) IBOutlet UISegmentedControl *mood;
@property (weak, nonatomic) IBOutlet UITextView * moodReason;
@property (weak, nonatomic) IBOutlet UIButton * backButton;

@end

@implementation MoodViewController

-(BOOL)textFieldShouldReturn:(UITextField *)textField
{
    return [textField resignFirstResponder];
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    self.firstName.delegate = self;
    self.lastName.delegate = self;
    self.firstName.text = self.currentMood.firstName;
    self.lastName.text = self.currentMood.lastName;
    self.moodReason.text = self.currentMood.moodReason;
    self.mood.selectedSegmentIndex = self.currentMood.selectedMood;
    self.moodReason.delegate = self;
    if (self.currentMood.isNew)
    {
        [self.backButton setTitle:@"Save" forState:UIControlStateNormal];
    }
    else
    {
        [self.backButton setTitle:@"Back" forState:UIControlStateNormal];
    }
    
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(BOOL) shouldPerformSegueWithIdentifier:(NSString *)identifier sender:(id)sender
{
    BOOL shouldPerformSegue = YES;
    if (self.currentMood.isNew)
    {
        if ([self isEmpty:self.firstName.text] || [self isEmpty:self.firstName.text] || [self isEmpty:self.moodReason.text])
        {
            shouldPerformSegue = NO;
            UIAlertView * alertView = [[UIAlertView alloc] initWithTitle:@"Empty Fields" message:@"Please fill out the entire and resubmit." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
            [alertView show];
        }
    }
    return shouldPerformSegue;
}

-(BOOL) isEmpty: (NSString *) text
{
    BOOL isEmpty = NO;
    NSString * trimmedString = [text stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
    if (trimmedString.length == 0)
    {
        isEmpty = YES;
    }
    return isEmpty;
}

- (BOOL)textView:(UITextView *)textView shouldChangeTextInRange:(NSRange)range replacementText:(NSString *)text {
    
    if([text isEqualToString:@"\n"]) {
        [textView resignFirstResponder];
        return NO;
    }
    
    return YES;
}

-(void) prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    self.currentMood.firstName = self.firstName.text;
    self.currentMood.lastName = self.lastName.text;
    self.currentMood.selectedMood = self.mood.selectedSegmentIndex;
    self.currentMood.moodReason = self.moodReason.text;
}

@end
